#include <bits/stdc++.h>

#define int long long

using namespace std;

signed main()
{
   ios::sync_with_stdio(false);
   cin.tie(0);
   int n, m;
   cin >> n >> m;
   int a[n + 1][m + 1];
   for(int i = 1; i <= n; i++) {
    for(int j = 1; j <= m; j++) {
        cin >> a[i][j];
    }
   }
   int dp[n + 1][m + 1];
   for(int i = 0; i <= n; i++) {
    for(int j = 0; j <= m; j++) {
        dp[i][j] = 1e18;
    }
   }
   dp[1][1] = 0;
   for(int i = 1; i <= n; i++) {
    for(int j = 1; j <= m; j++) {
        // doso od iznad
        int r = 0;
        int p = 0;
        for(int k = j; k > 0; k--) {
            r += p * a[i][k];
            p += 1;
        }
        dp[i][j] = min(dp[i - 1][j] + r, dp[i][j]);
        r = 0;
        p = 0;
        for(int k = i; k > 0; k--) {
            r += p * a[k][j];
            p += 1;
        }
        dp[i][j] = min(dp[i][j - 1] + r, dp[i][j]);
    }
   }
   cout << dp[n][m];
}